<script lang="ts">
import Component from 'vue-class-component';
import { Prop, PropSync } from 'vue-property-decorator';
import type {
  Unit, Onset, Pixel, Second,
} from '@/data';
import { PixelUnitWithSeconds } from '@/data';
import PixelUtils from '@/data/PixelUtils';
import type { Image3DPageData } from '@/data/Source';
import LabelBehavior from '../LabelBehavior.vue';

/**
 * Set player position using shift click
 */
@Component
export default class BSeekAndPlayOnDoubleClick extends LabelBehavior {
  mounted() {
    this.register('staff-dblclick', (e) => {
      const pixel = PixelUtils.getMuxPixelFromPosition(this.pages, e.x, e.y);
      if (PixelUnitWithSeconds.isUnitWithSeconds(this.pixelUnit)) {
        this.realTime = this.pixelUnit.fromPixelToSecond(pixel);
      } else {
        this.musicalTime = this.pixelUnit.toOnset(pixel).value;
      }
      if (!this.isPlaying) {
        this.isPlaying = true;
      }
    });
  }

  @Prop()
  pixelUnit!: Unit<Pixel>;

  @PropSync('time', { required: false })
  musicalTime!: Onset;

  @PropSync('realTimeSync', { required: false })
  realTime!: Second;

  @Prop()
  pages!: Array<Image3DPageData>;

  @PropSync('playing', { required: true })
  isPlaying!: boolean;
}
</script>
